#include "systemc.h"

class MyModule: public sc_module {
public:
  int x, y, z, o;

  SC_HAS_PROCESS(MyModule);

  MyModule(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(my_cthread1);
    SC_THREAD(my_cthread2);
    SC_THREAD(my_cthread3);
  }

  void my_cthread1()
  {
    /* some initialization */
    x = 42;

    // First wait statement
    wait();

    /* computation and communication */
    int l = x * y * z * o;
    /* computation and communication */
  }

  void my_cthread2()
  {
    /* some initialization */
    y = 43;
//    o = 44;

    // First wait statement
    wait();

    /* computation and communication */
    int l = x * y * z;
    /* computation and communication */
  }

  void my_cthread3()
  {
    /* some initialization */
    z = 44;

    // First wait statement
    wait();

    /* computation and communication */
    int l = x * y * z;
    /* computation and communication */
  }
};


int sc_main(int argc, char **argv)
{
  MyModule mm("mm");

  sc_start();
  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
