#!/bin/sh
# min_data_conflict_table.sh
# 04/29/19, RD

set -e

if [ $# -ne 1 ]; then
	echo "$0: Missing argument!"
	echo "Usage: $0 <NAME_data_conflict_table.html>"
	exit 10
fi

x="_data_conflict_table.html"
n=`basename $1 $x`
d=`dirname $1`
fin=$d/$n$x
fout=$d/$n\_min$x

if [ -f $fin ]; then
#	if [ -f $fout ]; then
#		echo "$0: $fout exists, aborted!"
#		exit 10
#	else
		echo "Input:  $fin"
		echo "Output: $fout"
		grep -v "<pre>" <$fin >$fout
#	fi
else
	echo "$0: File not found: $fin"
	exit 10
fi

echo "Done."

# EOF
