#include "initiatorsocket.h"

risc::InitiatorSocket::InitiatorSocket(SgVariableDefinition *ast_node, Class *parent):
  Socket(ast_node, parent, InitiatorSocketType),
  registered_nb_transport_bw_(NULL)
{ }

void risc::InitiatorSocket::get_mapped_sockets(
	std::set<risc::Socket*> &mapped_sockets)
{
	risc::Socket::helper_get_mapped_sockets(mapped_sockets, true);
}

void risc::InitiatorSocket::register_nb_transport_bw(
	SgFunctionDeclaration* func_decl)
{
	is_end_ = true;
	registered_nb_transport_bw_ = func_decl;
}

SgFunctionDeclaration* risc::InitiatorSocket::get_registered_nb_transport_bw()
{
	return registered_nb_transport_bw_;
}



/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
