#include "systemc.h"

class DoWhileBreak: public sc_module {
public:
//  int x, y, z;
//  sc_event e;
  bool test, test1;

  SC_HAS_PROCESS(DoWhileBreak);

  void do_while_break_1()
  {
    wait();
    int kk;
    do {
      int aa;
      wait();
      int bb;
      break;
    } while(test);

    int cc;
    wait();
    int dd;
  }

  void do_while_break_2()
  {
    wait();
    int kk;
    do {
      int aa;
      if(test)
        break;
      int bb;

      do {
        int uu;
        break;
        int oo;
      } while(test);
    } while(test1);
    int cc;
    wait();
    int dd;
  }

  void do_while_break_3()
  {
    int kk;
    do {
      int aa;
      wait();
      int bb;
      if(test) {
        break;
      }
      int oo;
      wait();
      int cc;
    } while(test);
    int dd;
    wait();
  }

  void do_while_break_4()
  {
    wait();
    int aa;
    do {
      break;
      int bb;
      wait();
      int cc;
      wait();
      int dd;
      wait();
      int ee;
    } while(test);
    int ff;
    wait();
    int gg;
  }

  DoWhileBreak(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(do_while_break_1);
    SC_THREAD(do_while_break_2);
    SC_THREAD(do_while_break_3);
    SC_THREAD(do_while_break_4);
  }
};


#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  DoWhileBreak mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
